# Snowflake

> JDBC Snowflake Source Connector[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/Snowflake#key-features)

### Key Features <a href="#supported-datasource-list" id="supported-datasource-list"></a>

* [x] &#x20;batch
* [ ] &#x20;stream
* [ ] &#x20;exactly-once
* [x] &#x20;column projection
* [x] &#x20;parallelism
* [x] &#x20;support user-defined split

> supports query SQL and can achieve projection effect.[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/Snowflake#description)

### Description[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/Snowflake#supported-datasource-list) <a href="#supported-datasource-list" id="supported-datasource-list"></a>

Read external data source data through JDBC.

### Data Type Mapping <a href="#supported-datasource-list" id="supported-datasource-list"></a>

| Snowflake Data type                                                               | Nexus Data type |
| --------------------------------------------------------------------------------- | --------------- |
| BOOLEAN                                                                           | BOOLEAN         |
| <p>TINYINT<br>SMALLINT<br>BYTEINT<br></p>                                         | SHORT\_TYPE     |
| <p>INT<br>INTEGER<br></p>                                                         | INT             |
| BIGINT                                                                            | LONG            |
| <p>DECIMAL<br>NUMERIC<br>NUMBER<br></p>                                           | DECIMAL(x,y)    |
| DECIMAL(x,y)(Get the designated column's specified column size.>38)               | DECIMAL(38,18)  |
| <p>REAL<br>FLOAT4</p>                                                             | FLOAT           |
| <p>DOUBLE<br>DOUBLE PRECISION<br>FLOAT8<br>FLOAT<br></p>                          | DOUBLE          |
| <p>CHAR<br>CHARACTER<br>VARCHAR<br>STRING<br>TEXT<br>VARIANT<br>OBJECT</p>        | STRING          |
| DATE                                                                              | DATE            |
| TIME                                                                              | TIME            |
| <p>DATETIME<br>TIMESTAMP<br>TIMESTAMP\_LTZ<br>TIMESTAMP\_NTZ<br>TIMESTAMP\_TZ</p> | TIMESTAMP       |
| <p>BINARY<br>VARBINARY</p>                                                        | BYTES           |
| <p>GEOGRAPHY (WKB or EWKB)<br>GEOMETRY (WKB or EWKB)</p>                          | BYTES           |
| <p>GEOGRAPHY (GeoJSON, WKT or EWKT)<br>GEOMETRY (GeoJSON, WKB or EWKB)</p>        | STRING          |

### Options[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/Snowflake#options) <a href="#options" id="options"></a>

| name                            | type       | required | default         | description                                                                                                                                                                                                                                                        |
| ------------------------------- | ---------- | -------- | --------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| url                             | String     | Yes      | -               | The URL of the JDBC connection. Refer to a case: jdbc:snowflake://\<account\_name>.snowflakecomputing.com                                                                                                                                                          |
| driver                          | String     | Yes      | -               | <p>The jdbc class name used to connect to the remote data source,<br>if you use Snowflake the value is <code>net.snowflake.client.jdbc.SnowflakeDriver</code>.</p>                                                                                                 |
| user                            | String     | No       | -               | Connection instance user name                                                                                                                                                                                                                                      |
| password                        | String     | No       | -               | Connection instance password                                                                                                                                                                                                                                       |
| query                           | String     | Yes      | -               | Query statement                                                                                                                                                                                                                                                    |
| connection\_check\_timeout\_sec | Int        | No       | 30              | The time in seconds to wait for the database operation used to validate the connection to complete                                                                                                                                                                 |
| partition\_column               | String     | No       | -               | The column name for parallelism's partition, only support numeric type,Only support numeric type primary key, and only can config one column.                                                                                                                      |
| partition\_lower\_bound         | BigDecimal | No       | -               | The partition\_column min value for scan, if not set Nexus will query database get min value.                                                                                                                                                                      |
| partition\_upper\_bound         | BigDecimal | No       | -               | The partition\_column max value for scan, if not set Nexus will query database get max value.                                                                                                                                                                      |
| partition\_num                  | Int        | No       | job parallelism | The number of partition count, only support positive integer. default value is job parallelism                                                                                                                                                                     |
| fetch\_size                     | Int        | No       | 0               | <p>For queries that return a large number of objects,you can configure<br>the row fetch size used in the query toimprove performance by<br>reducing the number database hits required to satisfy the selection criteria.<br>Zero means use jdbc default value.</p> |
| properties                      | Map        | No       | -               | <p>Additional connection configuration parameters,when properties and URL have the same parameters, the priority is determined by the<br>specific implementation of the driver. For example, in MySQL, properties take precedence over the URL.</p>                |
| common-options                  |            | No       | -               | Source plugin common parameters, please refer to [source-common-options](https://docs.selfuel.digital/data-integration-with-nexus/nexus-elements/connectors/source/source-common-options "mention") for details                                                    |

### tips[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/Snowflake#tips) <a href="#tips" id="tips"></a>

> If partition\_column is not set, it will run in single concurrency, and if partition\_column is set, it will be executed in parallel according to the concurrency of tasks.
>
> JDBC Driver Connection Parameters are supported in JDBC connection string. E.g, you can add `?GEOGRAPHY_OUTPUT_FORMAT='EWKT'` to specify the Geospatial Data Types. For more information about configurable parameters, and geospatial data types please visit Snowflake official [document](https://docs.snowflake.com/en/sql-reference/data-types-geospatial)

### Task Example[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/Snowflake#task-example) <a href="#task-example" id="task-example"></a>

#### simple:[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/Snowflake#simple) <a href="#simple" id="simple"></a>

> This example queries type\_bin 'table' 16 data in your test "database" in single parallel and queries all of its fields. You can also specify which fields to query for final output to the console.
>
> ```
> # Defining the runtime environment
> env {
> parallelism = 2
> job.mode = "BATCH"
> }
> source{
> Jdbc {
> url = "jdbc:snowflake://<account_name>.snowflakecomputing.com"
> driver = "net.snowflake.client.jdbc.SnowflakeDriver"
> connection_check_timeout_sec = 100
> user = "root"
> password = "123456"
> query = "select * from type_bin limit 16"
> }
> }
> transform {
> # If you would like to get more information about how to configure Nexus and see full list of transform plugins,
> # please go to transform page
> }
> sink {
> Console {}
> }
> ```

#### parallel:[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/Snowflake#parallel) <a href="#parallel" id="parallel"></a>

> Read your query table in parallel with the shard field you configured and the shard data You can do this if you want to read the whole table
>
> ```
> Jdbc {
> url = "jdbc:snowflake://<account_name>.snowflakecomputing.com"
> driver = "net.snowflake.client.jdbc.SnowflakeDriver"
> connection_check_timeout_sec = 100
> user = "root"
> password = "123456"
> # Define query logic as required
> query = "select * from type_bin"
> # Parallel sharding reads fields
> partition_column = "id"
> # Number of fragments
> partition_num = 10
> }
> ```

#### parallel boundary:[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/Snowflake#parallel-boundary) <a href="#parallel-boundary" id="parallel-boundary"></a>

> It is more efficient to specify the data within the upper and lower bounds of the query It is more efficient to read your data source according to the upper and lower boundaries you configured
>
> ```
> Jdbc {
> url = "jdbc:snowflake://<account_name>.snowflakecomputing.com"
> driver = "net.snowflake.client.jdbc.SnowflakeDriver"
> connection_check_timeout_sec = 100
> user = "root"
> password = "123456"
> # Define query logic as required
> query = "select * from type_bin"
> partition_column = "id"
> # Read start boundary
> partition_lower_bound = 1
> # Read end boundary
> partition_upper_bound = 500
> partition_num = 10
> }
> ```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.selfuel.digital/data-integration-with-nexus/nexus-elements/connectors/source/snowflake.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
